     *_> CNLLSTSPLF SRCFILE(@2/@1) SRCMBR(@3)                                                                          
     *_> DLTMOD MODULE(@5/@4)                                                                                          
     *_> CRTRPGMOD MODULE(@5/@4) SRCFILE(@2/@1) SRCMBR(@3) +                                                           
     *_>   DBGVIEW(@9) OPTIMIZE(@8)                                                                                    
     * ---------------------------------------------------------------                                                 
     * Module.: TG0002_M02           Project.....:                                                                     
     * Author.: A. Campin            Date written: 04/03/2005                                                          
     * Purpose: Screen Two. Get Trigger Control Data.                                                                  
     * ---------------------------------------------------------------                                                 
     * Called by: TG0002_M01                                                                                           
     * ---------------------------------------------------------------                                                 
     * Revision history:                                                                                               
     *  Project # Pgmr        Date   Desc                                                                              
     *                                                                                                                 
     * End Revision History                                                                                            
     * ---------------------------------------------------------------                                                 
     *                  Standards                                                                                      
     *                  Function Keys.                                                                                 
     *                                                                                                                 
     *  F3  - SAA Exit.                                                                                                
     *  F12 - Previous Screen.                                                                                         
     * ---------------------------------------------------------------                                                 
     *                       Indicators                                                                                
     *                                                                                                                 
     * @@@ Indicators 1 - 25 for data base I/O.                                                                        
     *                                                                                                                 
     *      01 - I/O to ___                                                                                            
     *                                                                                                                 
     * @@@ Indicators 26 - 29 for subfile control.                                                                     
     *                                                                                                                 
     *      26 - Display subfile control.                                                                              
     *      27 - Display subfile.                                                                                      
     *      28 - Clear subfile.                                                                                        
     *      29 - SFLEND enabled.                                                                                       
     *                                                                                                                 
     * @@@ Indicators 30 - 49 display file I/O control.                                                                
     *                                                                                                                 
     *      30 - I/O to ___.                                                                                           
     *                                                                                                                 
     * @@@ Indicators 50 - 79 field error indicators.                                                                  
     *                                                                                                                 
     * @@@ Indicators 80 - 94 Condition control.                                                                       
     *                                                                                                                 
     * @@@ Indicators 95 - 99 Scratch indicators.                                                                      
     *                                                                                                                 
     *      95 - Subfile message handler.                                                                              
     *      99 - Scratch indicator.                                                                                    
     * ---------------------------------------------------------------                                                 
      /EJECT                                                                                                            
     h NoMain                                                                                                           
                                                                                                                        
     fTG0002_D01cf   e             WorkStn InfDs(FI01)                                                                  
     f                                     UsrOpn                                                                       
     f                                     Include(RD01_02:                                                             
     f                                             SFMSG_CTL)                                                           
                                                                                                                        
      /copy *libl/qsrcf,cb_Std_Con                                                                                      
                                                                                                                        
      /copy *libl/qsrcf,cb_StdType                                                                                      
                                                                                                                        
      /copy *libl/qsrcf,XVMSGF_PR                                                                                       
                                                                                                                        
      /copy *libl/qsrcf,XVUSPC_PR                                                                                       
                                                                                                                        
      /copy *libl/qsrcf,TG0002_LP                                                                                       
                                                                                                                        
      /Define cb_DisplaySubfileMessages_PR                                                                              
      /copy *libl/qsrcf,CB_DSPSFM                                                                                       
      /Undefine cb_DisplaySubfileMessages_PR                                                                            
                                                                                                                        
     d LoadScreenFields...                                                                                              
     d                 pr                                                                                               
                                                                                                                        
     d ValidInput...                                                                                                    
     d                 pr                  Like(StdLgl)                                                                 
                                                                                                                        
     d Update...                                                                                                        
     d                 pr                  Like(StdLgl)                                                                 
                                                                                                                        
     d ProgramName...                                                                                                   
     d                 s                   Like(StdNam)                                                                 
     d                                     Import                                                                       
                                                                                                                        
     d FI01...                                                                                                          
     d                 ds                  Qualified                                                                    
     d   KeyPressed...                                                                                                  
     d                       369    369                                                                                 
                                                                                                                        
     d SystemDataStructure...                                                                                           
     d                sds           333    Qualified                                                                    
     d   ModuleName...                                                                                                  
     d                         1     10                                                                                 
     d   UserName...                                                                                                    
     d                       254    263                                                                                 
                                                                                                                        
      /copy *libl/qsrcf,CB_MAP_IND                                                                                      
     d DisplaySubfileEndOnSubfileMessageQueue...                                                                        
     d                                     Like(StdLgl)                                                                 
     d                                     Overlay(GenericIN95)                                                         
     *- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -    -*                                          
     * Data Structure for Trigger Control Header. Mapped to User Space                                                 
     *  TG_CTRL_HDR.                                                                                                   
     d TriggerHeader...                                                                                                 
     d               e ds                  Qualified                                                                    
     d                                     ExtName(TGCTRLH)                                                             
     d                                     Based(ptrTriggerHeader)                                                      
                                                                                                                        
     d cMainProcedureName...                                                                                            
     d                 c                   Const('PROCESSSCREEN02')                                                     
     d ScreenOpen...                                                                                                    
     d                 s                   Like(StdLgl)                                                                 
     d                                     Inz(cFalse)                                                                  
     * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -                                             
     * ProcessScreen02                                                                                                 
     *   Do Processin for Screen 2 - Standard Input Panel.                                                             
     *   Input     - None                                                                                              
     *   Out       - None.                                                                                             
     *   Returns   - Key Pressed.                                                                                      
     * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -                                             
     p ProcessScreen02...                                                                                               
     p                 b                   Export                                                                       
     d                 pi                  like(StdChr)                                                                 
                                                                                                                        
      /copy *libl/qsrcf,CB_KEYP                                                                                         
                                                                                                                        
      /Free                                                                                                             
                                                                                                                        
         If Not ScreenOpen;                                                                                             
           ScreenOpen = cTrue;                                                                                          
           Open TG0002_D01;                                                                                             
         EndIf;                                                                                                         
                                                                                                                        
         If ptrTriggerHeader = *Null;                                                                                   
           ptrTriggerHeader = USPC_GetPointerToUserSpace('TG_CTRL_HDR':                                                 
                                                         '*LIBL'      );                                                
         EndIf;                                                                                                         
                                                                                                                        
         LoadScreenFields();                                                                                            
                                                                                                                        
         MSGF_ClearProgramMessageQueue(cMainProcedureName            :                                                  
                                       SystemDataStructure.ModuleName:                                                  
                                       ProgramName                   );                                                 
         DoU 0 = 1;                                                                                                     
                                                                                                                        
           DisplaySubfileMessages();                                                                                    
           ExFmt RD01_02;                                                                                               
                                                                                                                        
           MSGF_ClearProgramMessageQueue(cMainProcedureName            :                                                
                                         SystemDataStructure.ModuleName:                                                
                                         ProgramName                   );                                               
                                                                                                                        
           MSGF_ClearErrorIndicators(*IN                  :                                                             
                                     cStartErrorIndicators:                                                             
                                     cEndErrorIndicators  );                                                            
                                                                                                                        
           Select;                                                                                                      
             When FI01.KeyPressed = F3 or                                                                               
                  FI01.KeyPressed = F12;                                                                                
                Return FI01.KeyPressed;                                                                                 
             Other;                                                                                                     
               If Not ValidInput();                                                                                     
                 Iter;                                                                                                  
               EndIf;                                                                                                   
                                                                                                                        
               If Not Update();                                                                                         
                 Iter;                                                                                                  
               EndIf;                                                                                                   
                                                                                                                        
               Return Enter;                                                                                            
           EndSl;                                                                                                       
         EndDo;                                                                                                         
                                                                                                                        
      /End-Free                                                                                                         
     p                 e                                                                                                
     * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -                                             
     * CloseScreen02                                                                                                   
     *   Closeout Screen 02.                                                                                           
     *   Input     - None.                                                                                             
     *   Out       - None.                                                                                             
     *   Returns   - None.                                                                                             
     * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -                                             
     p CloseScreen02...                                                                                                 
     p                 b                   Export                                                                       
     d                 pi                                                                                               
      /Free                                                                                                             
                                                                                                                        
         If %Open(TG0002_D01);                                                                                          
           Close TG0002_D01;                                                                                            
           ScreenOpen = cFalse;                                                                                         
         EndIf;                                                                                                         
                                                                                                                        
      /End-Free                                                                                                         
     p                 e                                                                                                
     * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -                                             
     * LoadScreenFields                                                                                                
     *   Load screen fields.                                                                                           
     *   Input     - None.                                                                                             
     *   Out       - None.                                                                                             
     *   Returns   - None.                                                                                             
     * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -                                             
     p LoadScreenFields...                                                                                              
     p                 b                                                                                                
     d                 pi                                                                                               
      /Free                                                                                                             
                                                                                                                        
         B_ACTIVE = TriggerHeader.THACTIVE;                                                                             
         B_RELOAD = cNo;                                                                                                
                                                                                                                        
         O_LASTDATE = %Char(%Date(TriggerHeader.THRELOADTS):*USA/);                                                     
         O_LASTTIME = %Char(%Time(TriggerHeader.THRELOADTS):*HMS:);                                                     
         O_LASTUSER = TriggerHeader.THRELOADUS;                                                                         
                                                                                                                        
      /End-Free                                                                                                         
     p                 e                                                                                                
     * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -                                             
     * ValidInput                                                                                                      
     *   Validate Input Fields.                                                                                        
     *   Input     - None.                                                                                             
     *   Out       - None.                                                                                             
     *   Returns   - Valid input. True or False.                                                                       
     * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -                                             
     p ValidInput...                                                                                                    
     p                 b                                                                                                
     d                 pi                  Like(StdLgl)                                                                 
      /Free                                                                                                             
                                                                                                                        
         Return cTrue;                                                                                                  
                                                                                                                        
      /End-Free                                                                                                         
     p                 e                                                                                                
     * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -                                             
     * Update                                                                                                          
     *   Do update of data base.                                                                                       
     *   Input     - None.                                                                                             
     *   Out       - None.                                                                                             
     *   Returns   - Valid input. True or False.                                                                       
     * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -                                             
     p Update...                                                                                                        
     p                 b                                                                                                
     d                 pi                  Like(StdLgl)                                                                 
      /Free                                                                                                             
                                                                                                                        
         TriggerHeader.THACTIVE   = B_ACTIVE;                                                                           
         TriggerHeader.THRELOADUS = SystemDataStructure.UserName;                                                       
         If B_RELOAD = cYes;                                                                                            
           B_RELOAD   = cNo;                                                                                            
           TriggerHeader.THRELOADTS = %TimeStamp();                                                                     
           MSGF_SendProgramMessage('UTG0001':                                                                           
                                   cXVMessageFileName            :                                                      
                                   ' '                           :                                                      
                                   cMainProcedureName            :                                                      
                                   SystemDataStructure.ModuleName:                                                      
                                   ProgramName                   );                                                     
                                                                                                                        
           // Force screen to redisplay.                                                                                
           Return cFalse;                                                                                               
         EndIf;                                                                                                         
                                                                                                                        
         Return cTrue;                                                                                                  
                                                                                                                        
      /End-Free                                                                                                         
     p                 e                                                                                                
      /Define cb_DisplaySubfileMessages_PI                                                                              
      /copy *libl/qsrcf,CB_DSPSFM                                                                                       
      /Undefine cb_DisplaySubfileMessages_PI                                                                            
