     *_> CNLLSTSPLF SRCFILE(@2/@1) SRCMBR(@3)
     *_> DLTMOD MODULE(@5/@4)
     *_> DLTPGM PGM(@5/@4)
     *_> CRTSQLRPGI OBJ(@5/@4) +
     *_>   SRCFILE(@2/@1) SRCMBR(@3) +
     *_>   OBJTYPE(*MODULE) +
     *_>   DBGVIEW(*SOURCE)
     *_> CRTPGM PGM(@5/@4) MODULE(@5/@4) ENTMOD(@5/@4) +
     *_>   BNDSRVPGM(XVDYNL XVUSPC) BNDDIR(QC2LE) +
     *_>   ACTGRP(*CALLER) USRPRF(*OWNER) AUT(*EXCLUDE)
     * ---------------------------------------------------------------
     * Program: TG_MED               Project.....:
     * Author.: A. Campin            Date written: 04/09/2005
     * Purpose: Trigger Mediator Program. This program is called by all
     *            files wanting to use a data base trigger program. Its
     *            only function is to call the approriate service program
     *            for that file. All other functionality is contained in
     *            service programs. This is done so that the only lock
     *            maintained on a program is on this program which is as
     *            simple as possible. If there is an error in a trigger
     *            program, we can repair it without having to bring
     *            down the entire system to remove the locks.
     *          All trigger service programs are loaded dynamically the
     *            first time they are needed. If a data base table is
     *            never opened up for update, the service program
     *            associated with that data base table will never be
     *            loaded!
     * ---------------------------------------------------------------
     * Called by: OS/400 Data Base.
     * ---------------------------------------------------------------
     * Revision history:
     *  Project # Pgmr        Date   Desc
     *
     * End Revision History
     * ---------------------------------------------------------------
      /EJECT
     h
      /copy *libl/qsrcf,TG_MED_PR

      /copy *libl/qsrcf,XVUSPC_PR

      /copy *libl/qsrcf,XVDYNL_PR

      /copy *libl/qsrcf,cb_StdType

      /copy *libl/qsrcf,cb_Std_Con

     d BSearchCompare...
     d                 pr                  Like(StdInt)
     d                                     ExtProc('BSearchCompare')
     d   PR_PointerToLookForValue...
     d                                     Like(StdPtr)
     d                                     Value
     d   PR_PointerToArrayElement...
     d                                     Like(StdPtr)
     d                                     Value

     d INT_MainLine...
     d                 pr

     d INT_FirstTimeProcessing...
     d                 pr

     d INT_LoadDetailRecords...
     d                 pr

     d EntryPoint...
     d                 pr                  ExtPgm('TG_MED')
     d   PR_InDbTriggerBuffer...
     d                            32767
     d   PR_InDbTriggerLength...
     d                                     Like(StdInt)

     *- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -    -*
     * Data Structure for Trigger Control Header. Mapped to User Space
     *  TG_CTRL_HD.
     d TriggerControlHeader...
     d               e ds                  Qualified
     d                                     Extname(TGCTRLH)
     d                                     Based(ptrTriggerControlHeader)

     d ptrBaseOfDetailRecords...
     d                 s                   Like(StdPtr)
     d                                     Inz(*Null)
     *- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -    -*
     * Structure of Detail Record available for triggers.
     d DetailRecord...
     d                 ds                  Qualified
     d                                     Based(ptrDetailRecord)
     d    FileName...
     d                                     Like(StdNam)
     d    LibraryName...
     d                                     Like(StdNam)
     d    ServiceProgramName...
     d                                     Like(StdNam)
     d    ServiceProgramLibrary...
     d                                     Like(StdNam)
     d    ServiceProcedure...
     d                               50
     d    pptrTriggerProcedure...
     d                                     Like(StdPrcPtr)

      /copy *libl/qsrcf,CB_DBTRG_S

     d NumberOfDetailRecordsLoaded...
     d                 s                   Like(StdInt)
     d                                     Inz(0)
     d LastReloadValue...
     d                 s                   Like(StdTMS)
     d                                     Inz(*LoVal)

     d EntryPoint...
     d                 pi
     d   InDbTriggerBuffer...
     d                            32767
     d   InDbTriggerLength...
     d                                     Like(StdInt)
      /Free

          INT_MainLine();
          Return;

      /End-Free
     * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
     * INT_MainLine
     *   Input       - None
     *   Out         - None
     *   Returns     - None
     * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
     p INT_MainLine...
     p                 b
     d                 pi

     d FindName...
     d                 pr                  Like(StdPtr)
     d                                     ExtProc('bsearch')
     d   PR_PtrLookForValue...
     d                                     Like(StdPtr)
     d                                     Value
     d   PR_PtrArrayElement...
     d                                     Like(StdPtr)
     d                                     Value
     d   PR_NumberOfElements...
     d                                     Like(StdIntUns)
     d                                     Value
     d   PR_SizeOfEachElement...
     d                                     Like(StdIntUns)
     d                                     Value
     d   PR_PtrCompareProcedure...
     d                                     Like(StdPrcPtr)
     d                                     Value

     d QualifiedFileName...
     d                 ds                  Qualified
     d  FileName...
     d                                     Like(StdNam)
     d  LibraryName...
     d                                     Like(StdNam)

     d ActivationMark...
     d                 s                   Like(StdInt)
     d MsgId...
     d                 s                   Like(StdMsgId)
     d QMessageFile...
     d                 s                   Like(StdQNam)
     d MessageData...
     d                            32767    Varying


      /Free

         If ptrTriggerControlHeader = *Null;
           INT_FirstTimeProcessing();
         EndIf;

         ptrDbTriggerBuffer = %Addr(InDbTriggerBuffer);

         // If Triggers not active, just return.
         If TriggerControlHeader.THACTIVE = cNo;
           Return;
         EndIf;

         // If reload timestamp has from last time program called or
         // original load, reload detail tables.
         If LastReloadValue <> TriggerControlHeader.THRELOADTS;
           LastReloadValue = TriggerControlHeader.THRELOADTS;
           INT_LoadDetailRecords();
         EndIf;

         // If not found, then not active for triggers.
         If NumberOfDetailRecordsLoaded <= 0;
           Return;
         EndIf;

         // See if file is active for triggers.
         QualifiedFileName.FileName    = DbTriggerBuffer.PhysicalFileName;
         QualifiedFileName.LibraryName = DbTriggerBuffer.PhysicalFileLibrary;
         ptrDetailRecord = FindName(%Addr(QualifiedFileName)   :
                                    ptrBaseOfDetailRecords     :
                                    NumberOfDetailRecordsLoaded:
                                    %Size(DetailRecord)        :
                                    %PAddr('BSearchCompare')   );
         If ptrDetailRecord = *Null;
           Return;
         EndIf;

         // If not loaded before, load the service program.
         If DetailRecord.pptrTriggerProcedure = *Null;
           ActivationMark =
             DYNL_ActivateServiceProgram(DetailRecord.ServiceProgramName   :
                                         DetailRecord.ServiceProgramLibrary);
           DetailRecord.pptrTriggerProcedure =
             DYNL_GetPointerToExportedProcedure(ActivationMark               :
                                                DetailRecord.ServiceProcedure);
         EndIf;

         // Call the procedure to handle this file.
         pptrCallProcedure = DetailRecord.pptrTriggerProcedure;
         Monitor;
           CallProcedure(InDbTriggerBuffer:
                         InDbTriggerLength);
          On-Error;
            If ERRH_GetLastMessage(Msgid       :
                                   QMessageFile:
                                   MessageData );
              ERRH_Throw(MsgId       :
                         QMessageFile:
                         MessageData );
            EndIf;
        EndMon;

          Return;

      /End-Free
     p                 e
     * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
     * INT_FirstTimeProcessing
     *   Input       - None
     *   Out         - None
     *   Returns     - None
     * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
     p INT_FirstTimeProcessing...
     p                 b
     d                 pi

     d cControlUserSpaceName...
     d                 c                   Const('TG_CTL_HDR')
     d cControlUserSpaceLibrary...
     d                 c                   Const('*LIBL')
      /Free

         ptrTriggerControlHeader =
            USPC_GetPointerToUserSpace(cControlUserSpaceName:
                                       cControlUserSpaceName);
         Return;

      /End-Free
     p                 e
     * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
     * INT_LoadDetailRecords
     *   Load the detail records into the data structure.
     *   Input       - None
     *   Out         - None
     *   Returns     - None
     * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
     p INT_LoadDetailRecords...
     p                 b
     d                 pi

     d cDetailUserSpaceName...
     d                 c                   Const('TGDTLUSRSP')
     d cDetailUserSpaceLibrary...
     d                 c                   Const('QTEMP')
     d cDetailUserSpaceText...
     d                 c                   Const('Trigger File Detail')
     d cCreateAuthority...
     d                 c                   Const('*ALL')
     d cReplaceObject...
     d                 c                   Const('*NO')
     d Count...
     d                 s                   Like(StdInt)
     d                                     Inz(0)
     d SQLFetch...
     d               e ds
     d                                     ExtName(TGCTRLD)
     d                                     Based(DummyPointer)

     d sqlFileName...
     d                 s                   Like(TDFILENAME)
     d sqlLibraryName...
     d                 s                   Like(TDLIBNAME)
     d sqlServiceProgram...
     d                 s                   Like(TDSRVPGM)
     d sqlServiceLibrary...
     d                 s                   Like(TDSRVLIB)
     d sqlServiceProcedure...
     d                 s                   Like(TDSRVPROC)
      /Free

         // Get a count of records in TGCTRLD with Active = 'Y'.
         Exsr srGetDtlCnt;
         If NumberOfDetailRecordsLoaded <= 0;
           Return;
         EndIf;

         Monitor;
           USPC_DeleteUserSpace(cDetailUserSpaceName   :
                                cDetailUserSpaceLibrary);
         On-Error;
         EndMon;


         USPC_CreateUserSpace(cDetailUserSpaceName          :
                              cDetailUserSpaceLibrary       :
                              %Size(DetailRecord) *
                                 NumberOfDetailRecordsLoaded:
                              cDetailUserSpaceText          :
                              cCreateAuthority              :
                              cReplaceObject                );

         ptrBaseOfDetailRecords =
              USPC_GetPointerToUserSpace(cDetailUserSpaceName:
                                         cDetailUserSpaceLibrary);

         Exsr srOpenTD;
         DoU 0 = 1;
           Exsr srGetTDRcd;
           If SQLCode < 0 or
              SQLCode = 100;
             Leave;
           EndIf;

           Count += 1;
           ptrDetailRecord = ptrBaseOfDetailRecords +
                              ((Count - 1) * %Size(DetailRecord));
           DetailRecord.FileName              = sqlFileName;
           DetailRecord.LibraryName           = sqlLibraryName;
           DetailRecord.ServiceProgramName    = sqlServiceProgram;
           DetailRecord.ServiceProgramLibrary = sqlServiceLibrary;
           DetailRecord.ServiceProcedure      = sqlServiceProcedure;
           DetailRecord.pptrTriggerProcedure  = *Null;
         EndDo;

         Exsr srCloseTD;

         Return;

      /End-Free
     * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
     * srGetDtlCnt -  Get Detail Count from TGCTRLD with Active = 'Y'
     * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
     csr   srGetDtlCnt   Begsr

     c/Exec SQL
     c+ Declare CountCursor Cursor For
     c+   Select Count(*)
     c+     From TGCTRLD
     c+     Where TDACTIVE = 'Y'
     c+   For Fetch Only
     c/End-Exec

     c/Exec SQL
     c+ Open CountCursor
     c/End-Exec

     c/Exec SQL
     c+ Fetch Next
     c+   From CountCursor
     c+   Into :NumberOfDetailRecordsLoaded
     c/End-Exec

     c/Exec SQL
     c+ Close CountCursor
     c/End-Exec

     csr                 EndSr
     * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
     * srOpenTD -   Open Cursor on TDCTRLD with active records.
     * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
     csr   srOpenTD      Begsr

     c/Exec SQL
     c+ Declare TDCursor Cursor For
     c+   Select TDFILENAME,
     c+          TDLIBNAME,
     c+          TDSRVPGM,
     c+          TDSRVLIB,
     c+          TDSRVPROC
     c+     From TGCTRLD
     c+     Where TDACTIVE = 'Y'
     c+   For Fetch Only
     c/End-Exec

     c/Exec SQL
     c+ Open TDCursor
     c/End-Exec

     csr                 EndSr
     * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
     *  srGetTDRecord - Get a detail record from SQL cursor.
     * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
     csr   srGetTDRcd    BegSR

     c/Exec SQL
     c+ Fetch Next
     c+   From TDCursor
     c+   Into :sqlFileName,
     c+        :sqlLibraryName,
     c+        :sqlServiceProgram,
     c+        :sqlServiceLibrary,
     c+        :sqlServiceProcedure
     c/End-Exec

     csr                 EndSr
     * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
     *  srCloseTD - Close SQL Cursor on TGCTRLD.
     * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
     csr   srCloseTD     BegSR

     c/Exec SQL
     c+ Close TDCursor
     c/End-Exec

     csr                 EndSr

     p                 e
     * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
     * BSearchCompare
     *   Called by bsearch to compare two values and return result.
     *   Input     - Pointer to Look for value.
     *               Pointer to Array Element.
     *   Out       - None
     *   Returns   - Result Code.
     * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
     p BSearchCompare...
     p                 b
     d                 pi                  Like(StdInt)
     d    PointerToLookForValue...
     d                                     Like(StdPtr)
     d                                     Value
     d    PointerToArrayElement...
     d                                     Like(StdPtr)
     d                                     Value

     d LookForKey...
     d                 s                   Like(StdQNam)
     d                                     Based(PointerToLookForValue)
     d ArrayElement...
     d                 s                   Like(StdQNam)
     d                                     Based(PointerToArrayElement)

     d cLessThan...
     d                 c                   Const(-1)
     d cGreaterThan...
     d                 c                   Const(1)
     d cEqualTo...
     d                 c                   Const(0)
      /Free

          Select;
            When LookForKey < ArrayElement;
              Return cLessThan;
            When LookForKey = ArrayElement;
              Return cEqualTo;
            When LookForKey > ArrayElement;
              Return cGreaterThan;
          EndSl;

      /End-Free
     p                 e
