     *_> CNLLSTSPLF SRCFILE(@2/@1) SRCMBR(@3)                                                                          
     *_> DLTMOD MODULE(@5/@4)                                                                                          
     *_> CRTRPGMOD MODULE(@5/@4) SRCFILE(@2/@1) SRCMBR(@3) +                                                           
     *_>   DBGVIEW(@9) OPTIMIZE(@8)                                                                                    
     * ---------------------------------------------------------------                                                 
     * Module.: XVRSLV_M01           Project.....:                                                                     
     * Author.: A. Campin            Date written: 02/23/2005                                                          
     * Purpose: Functions to Resolve an AS/400 Object to a System                                                      
     *            Pointer.                                                                                             
     * ---------------------------------------------------------------                                                 
     * Revision history:                                                                                               
     *  Project # Pgmr        Date   Desc                                                                              
     *                                                                                                                 
     * End Revision History                                                                                            
     * ---------------------------------------------------------------                                                 
      /EJECT                                                                                                            
     h nomain                                                                                                           
                                                                                                                        
      /copy *libl/qsrcf,cb_StdType                                                                                      
                                                                                                                        
      /copy *libl/qsrcf,cb_Std_Con                                                                                      
                                                                                                                        
      /copy *libl/qsrcf,XVRSLV_PR                                                                                       
                                                                                                                        
      /copy *libl/qsrcf,XVERRH_PR                                                                                       
                                                                                                                        
     d ConvertObjectTypeToHex...                                                                                        
     d                 pr             2                                                                                 
     d   PR_InObjectType...                                                                                             
     d                                     Like(StdNam)                                                                 
     d                                     Value                                                                        
     *= = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = =                                            
     * RSLV_ResolveToSystemPointer                                                                                     
     *   Function is responsilble for getting a system pointer to an                                                   
     *     AS/400 system object.                                                                                       
     *  In     Parms  - Object Name.                                                                                   
     *                  Object Library.                                                                                
     *                  AS/400 Object Type.                                                                            
     *  In/Out Parms  - None.                                                                                          
     *  Out    Parms  -                                                                                                
     *  Return        - System Pointer.                                                                                
     *= = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = =                                            
     p RSLV_ResolveToSystemPointer...                                                                                   
     p                 b                   Export                                                                       
     d                 pi                  Like(StdPrcPtr)                                                              
     d   InObjectName...                                                                                                
     d                                     Like(StdNam)                                                                 
     d                                     Value                                                                        
     d   InObjectLibrary...                                                                                             
     d                                     Like(StdNam)                                                                 
     d                                     Value                                                                        
     d   InObjectType...                                                                                                
     d                                     Like(StdNam)                                                                 
     d                                     Value                                                                        
                                                                                                                        
     d ResolveToPointer...                                                                                              
     d                 pr                  ExtProc('rslvsp')                                                            
     d                                     Like(StdPrcPtr)                                                              
     d   PR_HexType...                                                                                                  
     d                                2    Value                                                                        
     d   PR_Object...                                                                                                   
     d                                     Like(StdPtr)                                                                 
     d                                     Value                                                                        
     d                                     Options(*String)                                                             
     d   PR_Library...                                                                                                  
     d                                     Like(StdPtr)                                                                 
     d                                     Value                                                                        
     d                                     Options(*String)                                                             
     d   PR_Authority...                                                                                                
     d                                2    Value                                                                        
                                                                                                                        
     d HexType...                                                                                                       
     d                 s              2                                                                                 
     d Authority...                                                                                                     
     d                 s              2    Inz(*LoVal)                                                                  
     d SystemPointer...                                                                                                 
     d                 s                   Like(StdPrcPtr)                                                              
     d                                     Noopt                                                                        
     d MessageId...                                                                                                     
     d                 s                   Like(StdMsgId)                                                               
     d QMessageFileName...                                                                                              
     d                 s                   Like(StdQNam)                                                                
     d MessageData...                                                                                                   
     d                 s          32767    Varying                                                                      
      /Free                                                                                                             
                                                                                                                        
         Monitor;                                                                                                       
           HexType = ConvertObjectTypeToHex(InObjectType);                                                              
         On-Error;                                                                                                      
           ERRH_GetLastMessage(MessageId       :                                                                        
                               QMessageFileName:                                                                        
                               MessageData     );                                                                       
           ERRH_Throw(MessageId       :                                                                                 
                      QMessageFileName:                                                                                 
                      MessageData     );                                                                                
         EndMon;                                                                                                        
                                                                                                                        
         SystemPointer = ResolveToPointer(HexType                :                                                      
                                          %TrimR(InObjectName)   :                                                      
                                          %TrimR(InObjectLibrary):                                                      
                                          Authority              );                                                     
         Return SystemPointer;                                                                                          
                                                                                                                        
      /End-Free                                                                                                         
     p                 e                                                                                                
     *= = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = =                                            
     * ConvertObjectTypeToHex                                                                                          
     *    Function is responsilble for taking an AS/400 object type and                                                
     *      converting it to an internal hex representation.                                                           
     *  In     Parms - Object Type                                                                                     
     *  In/Out Parms - None.                                                                                           
     *  Out    Parms - None.                                                                                           
     *  Return       - Hex System Type.                                                                                
     *= = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = =                                            
     p ConvertObjectTypeToHex...                                                                                        
     p                 b                                                                                                
     d                 pi             2                                                                                 
     d   InObjectType...                                                                                                
     d                                     Like(StdNam)                                                                 
     d                                     Value                                                                        
                                                                                                                        
      /copy *libl/qsrcf,CB_STD_EM                                                                                       
                                                                                                                        
     d ApiQLICVTTP     pr                  ExtPgm('QLICVTTP')                                                           
     d   PR_ConversionType...                                                                                           
     d                                     Like(StdNam)                                                                 
     d                                     Const                                                                        
     d   PR_ObjectType...                                                                                               
     d                                     Like(StdNam)                                                                 
     d                                     Const                                                                        
     d   PR_HexType...                                                                                                  
     d                                2                                                                                 
     d   PR_APIErrorReturn...                                                                                           
     d                                     LikeDs(StdErrorModel)                                                        
                                                                                                                        
     d HexType...                                                                                                       
     d                 s              2    Inz(*Loval)                                                                  
     d ApiError...                                                                                                      
     d                 ds                  LikeDs(StdErrorModel)                                                        
      /Free                                                                                                             
                                                                                                                        
         ApiQLICVTTP('*SYMTOHEX' :                                                                                      
                     InObjectType:                                                                                      
                     HexType     :                                                                                      
                     ApiError    );                                                                                     
                                                                                                                        
         If ApiError.BytesAvailable > 0;                                                                                
            ERRH_Throw(ApiError.MessageId  :                                                                            
                       cCPFMessageFileName :                                                                            
                       ApiError.MessageData);                                                                           
         Else;                                                                                                          
            Return HexType;                                                                                             
         EndIf;                                                                                                         
                                                                                                                        
      /End-Free                                                                                                         
     p                 e                                                                                                
